--[[
Name: LibSpecialEvents-LearnSpell-4.0
Revision: $Rev: 77468 $
Author: Tekkub Stoutwrithe (tekkub@gmail.com)
Website: http://www.wowace.com/
Description: Special events for mail (received, auction notices, etc)
Dependencies: LibStub, CallbackHandler-1.0
]]

local vmajor, vminor = "LibSpecialEvents-LearnSpell-4.0", "$Revision: 77468 $"

local lib, oldMinor = LibStub:NewLibrary(vmajor, vminor)
if not lib then return end

local closedelay = 5


local frame
if lib.frame then
	frame = lib.frame
	frame:UnregisterAllEvents()
	frame:SetScript("OnEvent", nil)
else
	frame = CreateFrame("Frame", vmajor .. "_Frame")
	lib.frame = frame
end

frame:RegisterEvent("SPELLS_CHANGED")

frame:SetScript("OnEvent", function(this, event, ...)
	this[event](lib, ...)
end)

local CallbackHandler = LibStub:GetLibrary("CallbackHandler-1.0")
if lib.callbacks then
	lib:UnregisterAll(lib)
	lib:UnhookDialogs()
else
	lib.callbacks = LibStub("CallbackHandler-1.0"):New(lib, nil, nil, "UnregisterAll")
end

if not lib.vars then lib.vars = {} end


--------------------------------
--      Tracking methods      --
--------------------------------

function frame:SPELLS_CHANGED()
	local newsp, oldsp = lib:GetSpellList(), lib.vars.spells

	for spell,rank in pairs(newsp) do
		if oldsp[spell] ~= rank then
			lib.callbacks:Fire("LearnedSpell", spell, rank)
		end
	end

	for i in pairs(oldsp) do oldsp[i] = nil end
	lib.vars.empty = oldsp
	lib.vars.spells = newsp
end


function lib:GetSpellList()
  local i, rt = 1, self.vars.empty or {}
	self.vars.empty = nil

  repeat
    local sname, srank = GetSpellName(i, BOOKTYPE_SPELL)
   	if sname then rt[sname] = srank end
  	i = i+1
		if sname then self.vars.allspells[sname..srank] = true end
	until not GetSpellName(i, BOOKTYPE_SPELL)

	return rt
end


-----------------------------
--      Query methods      --
-----------------------------

function lib:GetSpells()
	return self.vars.spells
end


function lib:SpellKnown(spell, rank)
	if not rank then return self.vars.spells[spell] end
	return self.vars.allspells[spell.. rank]
end

if not lib.vars.allspells then
    lib.vars.allspells = {}
    lib.vars.spells = lib:GetSpellList()
end